<?php

/**
 * no_novedad caracterizacion de funcionario actions.
 *
 * @package    nomina
 * @subpackage no_novedad caracterizacion de funcionario_
 * @author     Manuel Enrique Paredes Lopez
 * @email mparedes@sofhouse.net
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class no_nov_tip_funcActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'NO_NOV_CARAC_FUNC',
        'NO_TIPO_DISCAPACIDAD',
        'NO_TIPO_COMUNIDAD',
        'NO_TIPO_PREPENSION',
        'NO_PERIODO_V'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'NO_TIPO_DISCAPACIDAD,LEFT'=>
        array(
            'id_tipo_discapacidad'=>'NO_NOV_CARAC_FUNC'
        ),
        'NO_TIPO_COMUNIDAD,LEFT'=>
        array(
            'id_tipo_comunidad'=>'NO_NOV_CARAC_FUNC'
        ),
        'NO_TIPO_PREPENSION,LEFT'=>
        array(
            'id_tipo_prepension'=>'NO_NOV_CARAC_FUNC'
         ),
        'NO_PERIODO_V,LEFT'=>
        array(
            'id_periodo'=>'NO_NOV_CARAC_FUNC'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'NO_NOV_CARAC_FUNC' =>
        array(
            'id_nov_carac_func' => 'id_nov_carac_func',
            'id_tipo_doc' => 'id_tipo_doc',
            'num_doc' => 'num_doc',
            'fecha' => 'fecha',
            'numero_doc'=>'numero_doc',
            'fecha_doc'=>'fecha_doc',
            'observaciones'=>'observaciones',
            'discapacidad'=>'discapacidad',
            'id_tipo_discapacidad'=>'id_tipo_discapacidad',
            'discapacidad_obs'=>'discapacidad_obs',
            'prepension'=>'prepension',
            'id_tipo_prepension'=>'id_tipo_prepension',
            'cabeza_familia'=>'cabeza_familia',
            'id_tipo_cab_fam'=>'id_tipo_cab_fam',
            'adjunto_cab_fam'=>'adjunto_cab_fam',
            'comunidad'=>'comunidad',
            'id_tipo_comunidad'=>'id_tipo_comunidad',
            'fuero_sindical'=>'fuero_sindical',
            'comunidad_lgbt'=>'comunidad_lgbt',
            'adjunto_dis'=>'adjunto_dis',
            'adjunto_prepension'=>'adjunto_prepension',
            'adjunto_comunidad'=>'adjunto_comunidad',
            'id_periodo' => 'id_periodo'
        ),
        'NO_TIPO_DISCAPACIDAD'=>
        array(
            'descripcion'=>'descripcion_d'
        ),
        'NO_TIPO_COMUNIDAD'=>
        array(
            'descripcion'=>'descripcion_c'
        ),
        'NO_TIPO_PREPENSION'=>
        array(
            'descripcion'=>'descripcion_p'
        ),
        'NO_PERIODO_V'=>
        array(
            'periodo' => 'periodo',
        )
    ); //por cada tabla especificar los campos del select

    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'NO_NOV_CARAC_FUNC' => array(
            'id_nov_carac_func,a' => array('!=' => array(-1)),
            'id_nov_carac_func,b' => array('=' => array('id_nov_carac_func')),
            'num_doc' => array('LIKEALLPLUS' => array('num_doc')),
            'fecha' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'id_tipo_doc' => array('=' => array('id_tipo_doc')),
            'id_periodo' => array('=' => array('id_periodo')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'NO_TIPO_DISCAPACIDAD'=>array(
            'id_tipo_discapacidad'=>array('='=>array('id_tipo_discapacidad'))
        ),'NO_TIPO_COMUNIDAD'=>array(
            'id_tipo_comunidad'=>array('='=>array('id_tipo_comunidad'))
        ),'NO_TIPO_PREPENSION'=>array(
            'id_tipo_prepension'=>array('='=>array('id_tipo_prepension'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(); // filtros de condicion or
    protected $fields_orderBy = array(
        'num_doc'
    ); //campos para el ordenamiento de la consulta
//    protected $table_field_obligatory = array('id_debito'); //campos obligatorios de filtro - estan en el request

    /*
     * Variables manejo de log
     */
    //true - consulta de administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Area';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;



    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_nov_carac_func'; //identificador de la tabla
    protected $id_names = array('id_nov_carac_func'); //llave primaria
    protected $field_names = array('id_nov_carac_func','id_tipo_doc', 'num_doc', 'id_periodo'
        ,'fecha','numero_doc','fecha_doc','discapacidad','id_tipo_discapacidad','adjunto_dis','discapacidad_obs','comunidad','id_tipo_comunidad','adjunto_comunidad','prepension','id_tipo_prepension','adjunto_prepension','observaciones','doc_soporte','comunidad_lgbt','cabeza_familia','adjunto_cab_fam'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'NO_NOV_CARAC_FUNC'; //tabla en la cual se aplican los cambios
    protected $has_activo = true; //si posee campo en la tabla de nombre activo ---- ESTADO PARA REGALIAS - CARTERA
    protected $has_vigencia = false; //si posee vigencia
    protected $has_cen_op = false; //si posee centro de operacion
    protected $has_id_cia = false; //si posee compañia
    protected $has_secuencia = false; //si posee secuencia la tabla - true si es por tabla, false - trigger
//    protected $en_mayuscula = true; // si se pone, se puede poner en mayucula con true y en minuscula con false, de lo contrario la pone tal cual la BD

    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_nov_carac_func'; //identificador unico de la tabla
    //false - Registrar log para list - consultar
    protected $log_list = false;
    //false - Registrar log para add - update - remove
    protected $log_crud = false;

    /**
     * Construccion de observacion perzonalizada
     * 
     * Toda variable para tomarla del request con el formato:
     * &request-variable&
     * 
     * false - observacion por defecto
     *
     * @var string 
     */
    protected $observacion_list = false;
    protected $observacion_add = false;
    protected $observacion_update = false;
    protected $observacion_remove = false;

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

         $logger = sfContext::getInstance()->getLogger();
        //valor por defecto
        $errors = null;
        
        $logger->info("Entro a validateAdd");
        
        $prepension = $request['id_tipo_prepension'];
        $aplica_prepension = $request['prepension'];
        
        if(isset($prepension)&&isset($aplica_prepension)){
            
            $num_doc = $request['num_doc'];
        
        $tipo_doc =$request['id_tipo_doc'];

        
        //sentencia sql
        $sql = <<<EOD
                SELECT 
       tab0.ID_PENSION_FUNC,
       tab0.ID_TIPO_DOC,
       tab0.NUM_DOC,
       tab0.ID_PERIODO,
       tab0.ESTADO,
       tab0.FECHA_DOC,
       tab0.NUMERO_DOC,
       tab0.FECHA_PENSION,
       tab0.ID_SUPTIPO_COTIZANTE
FROM NO_PENSION_FUNC tab0
where tab0.ID_TIPO_DOC = $tipo_doc
and tab0.NUM_DOC = $num_doc
and tab0.ESTADO = 1
EOD;
        //ejecuta el sql
        $records = CN_TABLE::executeSQL($sql);
        if (count($records) > 0){
            $errors['mensaje'] = "Ya se encuentra pensionado este usuario ";
                $errors['servicio'] = "no_nov_tip_func";
                $logger->info("Ya se encuentra pensionado este usuario.");
            
        }

            
            
            
        }
        
        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {
        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
         
         
        if(isset($list_data_post[0]['discapacidad'])){
            if($list_data_post[0]['discapacidad']==true){
                $discapacidad=1;
                
            }else{
               $discapacidad=0;
            }
            
            
        }else{
                $discapacidad=0;
            }
        
        
         if(isset($list_data_post[0]['prepension'])){
            if($list_data_post[0]['prepension']==true){
                $prepension=1;
            }else{
                $prepension=0;
            }
            
            
        }else{
              $prepension=0;
            }
        
        if(isset($list_data_post[0]['cabeza_familia'])){
            if($list_data_post[0]['cabeza_familia']==true){
                $cabeza_familia=1;
            }else{
               $cabeza_familia=0;
            }
            
            
        }else{
                $cabeza_familia=0;
            }
        
         if(isset($list_data_post[0]['comunidad'])){
            if($list_data_post[0]['comunidad']==true){
               $comunidad=1;
            }else{
                $comunidad=0;
            }
            
            
        }else{
                $comunidad=0;
            }
        
        if(isset($list_data_post[0]['fuero_sindical'])){
            if($list_data_post[0]['fuero_sindical']==true){
               $fuero_sindical=1;
            }else{
                $fuero_sindical=0;
            }
            
            
        }else{
                $fuero_sindical=0;
            }
            
            
        if(isset($request['comunidad_lgbt'])){
            if($request['comunidad_lgbt']==true){
               $comunidad_lgbt=1;
            }else{
                $comunidad_lgbt=0;
            }
            
            
        }else{
                $comunidad_lgbt=0;
            }    
        
        
        if(!isset($list_data_post[0]['discapacidad_obs'])){   
            $discapacidad_obs=' ';
        }else{
            
            $discapacidad_obs=$list_data_post[0]['discapacidad_obs'];
        }
        
        
        
        if(!isset($list_data_post[0]['id_tipo_discapacidad'])){
           
             $id_tipo_discapacidad=0;
            
        }else{
            $id_tipo_discapacidad=$list_data_post[0]['id_tipo_discapacidad'];
        }
        
         if(!isset($list_data_post[0]['id_tipo_prepension'])){
           
             $id_tipo_prepension=0;
            
        }else{
            $id_tipo_prepension=$list_data_post[0]['id_tipo_prepension'];
        }
        
         if(!isset($list_data_post[0]['id_tipo_cab_fam'])){
           
             $id_tipo_cab_fam=0;
            
        }else{
            $id_tipo_cab_fam=$list_data_post[0]['id_tipo_cab_fam'];
        }
        
        if(!isset($list_data_post[0]['adjunto_cab_fam'])){
           
             $adjunto_cab_fam=null;
            
        }else{
            $adjunto_cab_fam=$list_data_post[0]['adjunto_cab_fam'];
        }
        
        
        
        
        
        
        if(!isset($list_data_post[0]['id_tipo_comunidad'])){
           
             $id_tipo_comunidad=0;
            
        }else{
            $id_tipo_comunidad=$list_data_post[0]['id_tipo_comunidad'];
        }
        $id_tipo_doc=$list_data_post[0]['id_tipo_doc'];
        $num_doc=$list_data_post[0]['num_doc'];
        
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
            
            
                        $sql = <<<EOD
                    
UPDATE DATOS_FUNCIONARIO
   SET 
       DISCAPACIDAD = $discapacidad,
       DISCAPACIDAD_OBS = '$discapacidad_obs',
       PREPENSION = $prepension,
       CABEZA_FAMILIA = $cabeza_familia,
       AFRODESCENDIENTE = $comunidad,
       FUERO_SINDICAL = $fuero_sindical,
       ID_TIPO_DISCAPACIDAD = $id_tipo_discapacidad,
       ID_TIPO_PREPENSION = $id_tipo_prepension,
       ID_TIPO_CAB_FAM = $id_tipo_cab_fam,
       ADJUNTO_CAB_FAM = '$adjunto_cab_fam',
       ID_TIPO_COMUNIDAD = $id_tipo_comunidad,
       COMUNIDAD_LGBT = $comunidad_lgbt                  
WHERE ID_TIPO_DOC = $id_tipo_doc
AND   NUM_DOC = '$num_doc'                                        
EOD;
            
            
            CN_TABLE::executeSQL($sql);
            
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
            
            
            $sql = <<<EOD
UPDATE DATOS_FUNCIONARIO
   SET 
       DISCAPACIDAD = $discapacidad,
       DISCAPACIDAD_OBS = '$discapacidad_obs',
       PREPENSION = $prepension,
       CABEZA_FAMILIA = $cabeza_familia,
       AFRODESCENDIENTE = $comunidad,
       FUERO_SINDICAL = $fuero_sindical,
       ID_TIPO_DISCAPACIDAD = $id_tipo_discapacidad,
       ID_TIPO_PREPENSION = $id_tipo_prepension,
       ID_TIPO_CAB_FAM = $id_tipo_cab_fam,
       ADJUNTO_CAB_FAM = '$adjunto_cab_fam',
       ID_TIPO_COMUNIDAD = $id_tipo_comunidad,
       COMUNIDAD_LGBT = $comunidad_lgbt                  
WHERE ID_TIPO_DOC = $id_tipo_doc
AND   NUM_DOC = '$num_doc'                                              
EOD;
            
            
            CN_TABLE::executeSQL($sql);
             
             
            /*
;
             * 
             *              */
            
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }
        $this->conn->commit();

        return $request;        
    }

}
